%clear all
MC     = 10;
K      = [1 4 10]; 
images = {'phantom','Cameraman256','Boat256','Cnes512','Champs512'};
imageso= {'phantom','Camera','Boat','Cnes','Champs'};

for in=1:length(images)
  eval(sprintf('load %s',images{in}));
  eval(sprintf('cd %s',[images{in} 'Noisy']));
  [n,n] = size(xo);
  
  for ik=1:length(K)
   eval(sprintf('cd K%d',K(ik)));
   for rep=1:MC
    eval(sprintf('load %sK%d_%dDFN.mat',images{in},K(ik),rep));
    [psnrDFN(in,ik,rep),maeDFN(in,ik,rep),eqmDFN(in,ik,rep)] = ers(xo,yhatTVCL1DR);
    
    eval(sprintf('load %sK%d_%dBS.mat',images{in},K(ik),rep));
    [psnrBS(in,ik,rep),maeBS(in,ik,rep),eqmBS(in,ik,rep)] = ers(xo,yhatBlock);
    
    eval(sprintf('load %sK%d_%dAA.mat',imageso{in},K(ik),rep));
    [psnrAA(in,ik,rep),maeAA(in,ik,rep),eqmAA(in,ik,rep)] = ers(xo,x);
    
    eval(sprintf('load %sK%d_%dSO.mat',imageso{in},K(ik),rep));
    [psnrSO(in,ik,rep),maeSO(in,ik,rep),eqmSO(in,ik,rep)] = ers(xo,x);
   end
   cd ..
  end
  figure
  subplot(121)
  errorbar(K,squeeze(mean(psnrDFN(in,:,:),3)),squeeze(std(psnrDFN(in,:,:),[],3)),'-b');hold on
  errorbar(K,squeeze(mean(psnrBS(in,:,:),3)),squeeze(std(psnrBS(in,:,:),[],3)),'--b');
  errorbar(K,squeeze(mean(psnrAA(in,:,:),3)),squeeze(std(psnrAA(in,:,:),[],3)),'-.b');
  errorbar(K,squeeze(mean(psnrSO(in,:,:),3)),squeeze(std(psnrSO(in,:,:),[],3)),':b');
  xlabel('K');ylabel('PSNR (dB)');axis tight
  title(sprintf('%s',images{in}));
  legend('Our method','Block-Stein','AA','SO');
  subplot(122)
  errorbar(K,squeeze(mean(maeDFN(in,:,:),3)),squeeze(std(maeDFN(in,:,:),[],3)),'-b');hold on
  errorbar(K,squeeze(mean(maeBS(in,:,:),3)),squeeze(std(maeBS(in,:,:),[],3)),'--b');
  errorbar(K,squeeze(mean(maeAA(in,:,:),3)),squeeze(std(maeAA(in,:,:),[],3)),'-.b');
  errorbar(K,squeeze(mean(maeSO(in,:,:),3)),squeeze(std(maeSO(in,:,:),[],3)),':b');
  %plot( K,squeeze(mean(maeDFN(in,:,:),3)),'-b', ...
  %   K,squeeze(mean(maeBS(in,:,:),3)),'--b', ...
  %   K,squeeze(mean(maeAA(in,:,:),3)),'-.b', ...
  %   K,squeeze(mean(maeSO(in,:,:),3)),':b');axis tight
  xlabel('K');ylabel('MAE');axis tight
  cd ..
  saveas(gcf,sprintf('%scomparepsnrmae.fig',images{in}),'fig');
  saveas(gcf,sprintf('%scomparepsnrmae.eps',images{in}),'epsc');
end

tilefigs


%
% Part of CurvL1MultDenoise Version:100
% Written by: Jalal Fadili, GREYC CNRS-ENSICAEN-Univ. Caen
%      	      Mila Nikolova, CMLA CNRS-ENS Cachan
%	      Sylvain Durand, MAP5 CNRS-Univ. Paris 5
% Created March 2009
% This is Copyrighted Material
% E-mail: Jalal.Fadili@greyc.ensicaen.fr
%
% Modified Wed Dec 16 18:43:04 CET 2009
%

