clear all
global dict pars1 pars2 pars3
MC     = 10;
K      = [1 4 10]; 
images = {'phantom','Cameraman256','Boat256','Cnes512','Champs512'};
maxIters=50;
%thd = [1.5 1.5 1.5 2 2;1.5 1.5 1.5 2 2;1.5 1.5 1.5 2 2]; % For some images e.g. Cameraman, cleaner but staircasing.
thd = [1.5 2.6 1.5 2 2;1.5 2.5 1.5 2 2;1.5 2.1 1.5 2 2];

% Dictionary of curvelets.
dict='CURVWRAP2';pars1=4;pars2=0;pars3=0;

tvoptions.dimension = '2';    % 2 for 2D images. Other fields are set to default values.
tvoptions.numdeep = 8;        % Depth of the dyadic search for the fast TV prox.
gamm = 10;		      % Relaxation parameter for Douglas-Rachford iteration.

% Regularization parameter phantom.
lambdaC(1,:,:)= 1.5*[0.2 2.5;0.2 4;0.2 4];      % K=1.  First: thresholded coeffs. Second: Kept coeffs.
			       		        % K=4.  First: thresholded coeffs. Second: Kept coeffs.
		    		                % K=10. First: thresholded coeffs. Second: Kept coeffs.

% Regularization parameter cameraman.
lambdaC(2,:,:)= [1.8 5.7;1.8 5.7;1.3 10];      % K=1.  First: thresholded coeffs. Second: Kept coeffs. Clean but staircasing: lambdaC(2,:,:)= [0.6 3;0.7 40;0.8 40].
			       		        % K=4.  First: thresholded coeffs. Second: Kept coeffs.
		    		                % K=10. First: thresholded coeffs. Second: Kept coeffs.

% Regularization parameter boat.
lambdaC(3,:,:)= [0.6 10;0.7 40;0.8 40];         % K=1.  First: thresholded coeffs. Second: Kept coeffs. % To avoid staircasing: [2.2 2.2;2.6 2.6;3.2 3.2].
			       		        % K=4.  First: thresholded coeffs. Second: Kept coeffs.
		    		                % K=10. First: thresholded coeffs. Second: Kept coeffs.

% Regularization parameter cnes.
lambdaC(4,:,:)= [1.5 10;1.5 10;1.3 10];         % K=1.  First: thresholded coeffs. Second: Kept coeffs.
			       		        % K=4.  First: thresholded coeffs. Second: Kept coeffs.
		    		                % K=10. First: thresholded coeffs. Second: Kept coeffs.
						
% Regularization parameter champs.
lambdaC(5,:,:)= [1.2 10;1.3 10;1.3 10];         % K=1.  First: thresholded coeffs. Second: Kept coeffs.
			       		        % K=4.  First: thresholded coeffs. Second: Kept coeffs.
		    		                % K=10. First: thresholded coeffs. Second: Kept coeffs.
for in=1:length(images)
  eval(sprintf('load %s',images{in}));
  eval(sprintf('cd %s',[images{in} 'Noisy']));%xo=xo(1:end/2,1:end/2);
  [n,n] = size(xo);
  % Coefficient vector length.
  p = SizeOfDict2(n,dict,pars1,pars2,pars3);
  tightFrame = p/(n*n); % The dictionary is a tight frame with constant p/(n*n).  
  
  for ik=1:3
   eval(sprintf('cd K%d',K(ik)));
   for rep=1:MC
    eval(sprintf('load %sK%d_%d.mat y',images{in},K(ik),rep));%y=y(1:end/2,1:end/2);
    v = log(y);
    
    % Denoise v by hard-thresholding in the curvelet (tight) frame with a small threshold => outliers in the coefficients domain.
    coeffv = FastA2(v,dict,pars1,pars2,pars3);
    cind   = fdct_wrapping_range(n,nextpow2(n)-pars1+1); % To get wedges indices in a vectorized form.
    coeffv(prod(cind{1}.sw)+1:end) = HardThresh(coeffv(prod(cind{1}.sw)+1:end),thd(ik,in)*sqrt(psi(1,K(ik)))); % Do not threshold approximation band.
    
    tvoptions.lmin = min(log(xo(:)));	% The solution is truncated to lmin/lmax.
    tvoptions.lmax = max(log(xo(:)));
    
    tic;yhatTVCL1DR= SolveTVL1CoeffsMultDouglasRachford('FastDictOp2D', coeffv, n*n, p, tvoptions, squeeze(lambdaC(in,ik,:))/tightFrame, gamm, tightFrame, maxIters, 0, 0);timeTVCL1DR=toc
    tic;yhatBlock = den2d_blockcurvwrap(v,2,6,4,sqrt(psi(1,K(ik))));timeBlock=toc
    % Take exp of the denoised log(image) and correct for bias due to exp of an estimate.
    yhatTVCL1DR = reshape(exp(yhatTVCL1DR)*(1+psi(1,K(ik))/2),n,n);
    yhatBlock   = reshape(exp(yhatBlock)*(1+psi(1,K(ik))/2),n,n);
    eval(sprintf('save -V6 %sK%d_%dDFN.mat yhatTVCL1DR',images{in},K(ik),rep));
    eval(sprintf('save -V6 %sK%d_%dBS.mat yhatBlock',images{in},K(ik),rep));
   end
   cd ..
  end
  cd ..
end




%
% Part of CurvL1MultDenoise Version:100
% Written by: Jalal Fadili, GREYC CNRS-ENSICAEN-Univ. Caen
%      	      Mila Nikolova, CMLA CNRS-ENS Cachan
%	      Sylvain Durand, MAP5 CNRS-Univ. Paris 5
% Created March 2009
% This is Copyrighted Material
% E-mail: Jalal.Fadili@greyc.ensicaen.fr
%
% Modified Wed Dec 16 18:43:04 CET 2009
%

