% Generate figure 2.

thd=[[2:6] 8];

% Dictionary of curvelets.
dict='CURVWRAP2';pars1=4;pars2=0;pars3=0;


load Lena256Noisy/K4/Lena256K4_1.mat
[n,n] = size(y);
p = SizeOfDict2(n,dict,pars1,pars2,pars3);
tightFrame = p/(n*n); % The dictionary is a tight frame with constant p/(n*n).

imagesc(y);axis image;axis off;drawnow
saveas(gcf,sprintf('lenanoisy.eps'),'epsc');

v = log(y);
coeffv = FastA2(v,dict,pars1,pars2,pars3);
cind   = fdct_wrapping_range(n,nextpow2(n)-pars1+1);
for it=1:length(thd)
 tmp=coeffv;
 tmp(prod(cind{1}.sw)+1:end) = HardThresh(coeffv(prod(cind{1}.sw)+1:end),thd(it)*sqrt(psi(1,4)));    
 yden   = exp(FastS2(tmp,n,dict,pars1,pars2,pars3)/tightFrame);   
 imagesc(yden);axis image;axis off;drawnow
 saveas(gcf,sprintf('lenathdlevel_%dsigma.eps',thd(it)),'epsc');
end

load Cameraman256Noisy/K4/Cameraman256K4_1.mat
[n,n] = size(y);
p = SizeOfDict2(n,dict,pars1,pars2,pars3);
tightFrame = p/(n*n); % The dictionary is a tight frame with constant p/(n*n).

imagesc(y);axis image;axis off;drawnow
saveas(gcf,sprintf('cameramannoisy.eps'),'epsc');

v = log(y);
coeffv = FastA2(v,dict,pars1,pars2,pars3);
cind   = fdct_wrapping_range(n,nextpow2(n)-pars1+1);
for it=1:length(thd)
 tmp=coeffv;
 tmp(prod(cind{1}.sw)+1:end) = HardThresh(coeffv(prod(cind{1}.sw)+1:end),thd(it)*sqrt(psi(1,4)));    
 yden   = exp(FastS2(tmp,n,dict,pars1,pars2,pars3)/tightFrame);   
 imagesc(yden);axis image;axis off;drawnow
 saveas(gcf,sprintf('cameramanthdlevel_%dsigma.eps',thd(it)),'epsc');
end

%
% Part of CurvL1MultDenoise Version:100
% Written by: Jalal Fadili, GREYC CNRS-ENSICAEN-Univ. Caen
%      	      Mila Nikolova, CMLA CNRS-ENS Cachan
%	      Sylvain Durand, MAP5 CNRS-Univ. Paris 5
% Created March 2009
% This is Copyrighted Material
% E-mail: Jalal.Fadili@greyc.ensicaen.fr
%
% Modified Wed Dec 16 18:43:04 CET 2009
%

