%clear all
MC     = 10;
K      = [1 4 10]; 
images = {'phantom','Cameraman256','Boat256','Cnes512','Champs512'};
imageso= {'phantom','Camera','Boat','Cnes','Champs'};

for in=1:length(images)
  eval(sprintf('load %s',images{in}));
  eval(sprintf('cd %s',[images{in} 'Noisy']));
  [n,n] = size(xo);
  
  for ik=1:length(K)
   eval(sprintf('cd K%d',K(ik)));
   for rep=1:MC
    eval(sprintf('load %sK%d_%dDFN.mat',images{in},K(ik),rep));
    [psnrDFN(in,ik,rep),maeDFN(in,ik,rep),eqmDFN(in,ik,rep)] = ers(xo,yhatTVCL1DR);
    
    eval(sprintf('load %sK%d_%dBS.mat',images{in},K(ik),rep));
    [psnrBS(in,ik,rep),maeBS(in,ik,rep),eqmBS(in,ik,rep)] = ers(xo,yhatBlock);
    
    eval(sprintf('load %sK%d_%dAA.mat',imageso{in},K(ik),rep));
    [psnrAA(in,ik,rep),maeAA(in,ik,rep),eqmAA(in,ik,rep)] = ers(xo,x);
    
    eval(sprintf('load %sK%d_%dSO.mat',images{in},K(ik),rep));
    [psnrSO(in,ik,rep),maeSO(in,ik,rep),eqmSO(in,ik,rep)] = ers(xo,x);
   end
   cd ..
  end
  cd ..
end

for in=1:length(images)
 fprintf('%s\n','*'*ones(1,90));
 fprintf('%40s%s\n',' ',imageso{in});
 fprintf('%s\n','*'*ones(1,90));
 
 fprintf('DFN ');
 for ik=1:length(K)
  fprintf('& %6.2f (%6.2f) ',squeeze(mean(psnrDFN(in,ik,:),3)),squeeze(std(psnrDFN(in,ik,:),[],3)));
 end
 fprintf(' \\\\\\hline\n');
 fprintf('BS  ');
 for ik=1:length(K)
  fprintf('& %6.2f (%6.2f) ',squeeze(mean(psnrBS(in,ik,:),3)),squeeze(std(psnrBS(in,ik,:),[],3)));
 end
 fprintf(' \\\\\\hline\n');
 fprintf('AA  ');
 for ik=1:length(K)
  fprintf('& %6.2f (%6.2f) ',squeeze(mean(psnrAA(in,ik,:),3)),squeeze(std(psnrAA(in,ik,:),[],3)));
 end
 fprintf(' \\\\\\hline\n');
 fprintf('SO  ');
 for ik=1:length(K)
  fprintf('& %6.2f (%6.2f) ',squeeze(mean(psnrSO(in,ik,:),3)),squeeze(std(psnrSO(in,ik,:),[],3)));
 end
 fprintf(' \\\\\\hline\n');
 
 fprintf('DFN ');
 for ik=1:length(K)
  fprintf('& %6.2f (%6.2f) ',squeeze(mean(maeDFN(in,ik,:),3)),squeeze(std(maeDFN(in,ik,:),[],3)));
 end
 fprintf(' \\\\\\hline\n');
 fprintf('BS  ');
 for ik=1:length(K)
  fprintf('& %6.2f (%6.2f) ',squeeze(mean(maeBS(in,ik,:),3)),squeeze(std(maeBS(in,ik,:),[],3)));
 end
 fprintf(' \\\\\\hline\n');
 fprintf('AA  ');
 for ik=1:length(K)
  fprintf('& %6.2f (%6.2f) ',squeeze(mean(maeAA(in,ik,:),3)),squeeze(std(maeAA(in,ik,:),[],3)));
 end
 fprintf(' \\\\\\hline\n');
 fprintf('SO  ');
 for ik=1:length(K)
  fprintf('& %6.2f (%6.2f) ',squeeze(mean(maeSO(in,ik,:),3)),squeeze(std(maeSO(in,ik,:),[],3)));
 end
 fprintf(' \\\\\\hline\n');
end
  

%
% Part of CurvL1MultDenoise Version:100
% Written by: Jalal Fadili, GREYC CNRS-ENSICAEN-Univ. Caen
%      	      Mila Nikolova, CMLA CNRS-ENS Cachan
%	      Sylvain Durand, MAP5 CNRS-Univ. Paris 5
% Created March 2009
% This is Copyrighted Material
% E-mail: Jalal.Fadili@greyc.ensicaen.fr
%
% Modified Wed Dec 16 18:43:04 CET 2009
%

