function [S,it,Vnew,V]=RISStvVar(y,lambda,alpha,dt,K,maxit);
% y = noisy image  
% K :  number of observations
% alpha, lambda - parameters
% dt - discretization step
% maxit - maximum number of iterations
%
% HOW TO RUN
%[S,it,Vnew,V]=RISStvVar(y,lambda,alpha,dt,K,maxit);

V=psi(1,K); %K=1 => 1.6499,  K=4 => 0.2838,  K=10 => 0.1052

[M,N]=size(y);
v=log(y);           clear y;
u=zeros(M,N);
mv=mean(v(:));
w=mv*ones(M,N);
epsi=1e-6;
Vnew=100*V;

it=0;
while ( Vnew>V & it<= maxit)
    it=it+1;
    
    [Gx,Gy]=gradxy(w);
    G=sqrt(Gx.^2+Gy.^2+epsi^2);
    Gx=Gx./G;
    Gy=Gy./G;
    clear G

    w=w+dt*(div(Gx,Gy)+lambda*(v-w+u));
    u=u+dt*alpha*(v-w);
    
    Vnew=var(w(:)-v(:),1);
    %if mod(it,2000)==0
    %    disp(['it=',num2str(it),' Vnew=',num2str(Vnew),' V=',num2str(V)]);
    %end
end
S=exp(w);
save TMP
%im(S);colormap gray;
%title(['riss : K=',num2str(K),' it=',num2str(it),' psnr=',num2str(p),' mae=',num2str(m),' lambda=',num2str(lambda),' alpha=',num2str(alpha),' dt=',num2str(dt)]);

%
% Part of CurvL1MultDenoise Version:100
% Written by: Jalal Fadili, GREYC CNRS-ENSICAEN-Univ. Caen
%      	      Mila Nikolova, CMLA CNRS-ENS Cachan
%	      Sylvain Durand, MAP5 CNRS-Univ. Paris 5
% Created March 2009
% This is Copyrighted Material
% E-mail: Jalal.Fadili@greyc.ensicaen.fr
%
% Modified Wed Dec 16 19:10:49 CET 2009
%

